import extra_geom

from ..base_geometry import ManualRelativePositionsGeometryBase


class FixedUpPnccdGeometry(extra_geom.PNCCDGeometry):
    # DetectorAssembler neeeds expected_data_shape to match actual data shape
    expected_data_shape = (1, 1024, 1024)

    # and these two methods need tweaking to avoid that breaking assertions
    def _ensure_shape(self, data):
        return data.reshape(self.expected_data_shape)

    def split_tiles(self, module_data):
        return [module_data[:512], module_data[512:]]

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.modules = [[self.modules[0][0], self.modules[1][0]]]


class PnccdGeometry(ManualRelativePositionsGeometryBase):
    geometry_class = FixedUpPnccdGeometry
