import numpy as np

from calng import shmem_utils


def test_change_shape():
    my_buffer = shmem_utils.ShmemCircularBuffer(
        1024 * 4,
        (2, 3),
        np.uint32,
        "test_shmem_buffer",
    )
    handles = []
    for i in range(3):
        handle, ary = my_buffer.next_slot()
        ary.fill(i)
        handles.append(handle)
    my_buffer.change_shape((5, 7))
    for i in range(3, 5):
        handle, ary = my_buffer.next_slot()
        ary.fill(i)
        handles.append(handle)
    receiver = shmem_utils.ShmemCircularBufferReceiver()
    # old handles don't get immediately mangled after change_shape
    for i, handle in enumerate(handles):
        ary = receiver.get(handle)
        assert np.all(ary == i)
